import React, { Component } from 'react';
import * as echarts from 'echarts';
import moment from 'moment'
class App extends Component {
    state={
        data:[],
        TopAxisX:[],
        BottomAxisX:[],
        TopAxisX1:[],
        AxisY:[],
        Links:[],
        target:[],
    }
  componentDidMount(){
    fetch('/api/graph_by_height_and_duration?height=0&duration=0',{
        method:'GET',
        headers:{
            'Content-Type':'application/json;charset=UTF-8'
        },
    })
    .then(res =>res.json())
    .then((data) => {
        this.setState({
            data:data.result.Rows,
            TopAxisX:data.result.AxisX.TopAxisX,
            BottomAxisX:data.result.AxisX.BottomAxisX,
            AxisY:data.result.AxisY,
            Links:data.result.Links,
        })
        
        var top=data.result.AxisX.TopAxisX
        var value=top.map(item=>{
            return item.Value;
        })
        var time=top.map(item=>{
            return item.Time;
        })
        console.log(time,'time')

console.log(data.result.AxisX.AxisXEnd-data.result.AxisX.AxisXBegin,'时间')


        var source= data.result.Rows
        var target=[];
        for(var i in source){
            var list=[];
            var lineList=source[i];
            for (var j in lineList) {
                list.push([
                    lineList[j].XAsTime/1000,
                    lineList[j].Type,
                    lineList[j].Y,
                    lineList[j].Desc,
                    lineList[j].Round,
                    lineList[j].Index,
                    lineList[j].ID,
                    lineList[j].Role
                ]);
            }
            
            target.push(list);
        }
        
       
        // console.log("target", target);









        var chartDom = document.getElementById('main');
        var myChart = echarts.init(chartDom);
        var option;
        const series = [];
        this.state.AxisY.forEach(function (type) {
             const arr = target.map(function (item) {
                const data = item.map((item, index) => {
                        var colors 
                        if(item[7]=='Normal'){
                            colors ='#4B4B4B'
                        }else if(item[7]=='Witness'){
                            colors ='#4A4CFF'
                        }else if(item[7]=='Famous1'){
                            colors ='#00FFFF'
                        }else if(item[7]=='Famous2'){
                            colors ='#06FF02'
                        }
                        


                    return {
                        label: {
                            show: true,
                            position: 'top'
                        },
                        emphasis: {
                            label: {
                                show: true,
                            }
                        },
                        name: item[6],
                        value: item,
                        // x: item[0],
                        itemStyle:{
                            normal:{
                                borderWidth: 1,
                                borderColor: '#333',
                                color:colors
                            }
                        },
                        symbolSize:item[3]==item[6]? 15 : 15 
                    }; 
                })
                return data;
            })
            var newArr=arr.reduce(function(total,currentValue){
                return total.concat(currentValue)
            })
            console.log(newArr,'newArr')
            // let xTime = newArr.map(item=>moment(Number(item.x)).format('YYYY-MM-DD HH:mm:ss:msms'))
            // console.log(xTime)
            let links = data.result.Links;
            links.map(item=>{
                item['source'] = item['Source']
                item['target'] = item['Target']
            })
            // links.pop();
            series.push({
                name: type,
                type: 'graph',
                coordinateSystem: 'cartesian2d',
                data: newArr,
                links: links,
                edgeSymbol: ['none', 'arrow'],
                edgeSymbolSize: 5,
                legendHoverLink: false,
                lineStyle: {
                    color: '#333'
                },
                itemStyle: {
                   normal:{
                    borderWidth: 1,
                    borderColor: '#333',
                   }
                },
                label: {
                    color: '#333',
                    position: 'center'
                },

                symbolSize: 15,
                
                // animationDelay: function (idx) {
                //     return idx * 100;
                // }
            });
            
        });
        
        option = {
            visualMap: {
                show: false,
                dimension: 1,
            },
            legend: {
                show: false,
                data: this.state.AxisY,
                
                selectedMode: 'single',
                right: 100
            },
            grid: {
                left: 0,
                bottom: 0,
                containLabel: true,
                top: 80
            },
            xAxis: [
                {
                    type: 'time',
                    axisLine:{
                        show: true
                    },
                    data:time,
                    axisTick: { //刻度线
                        alignWithLabel:true,  //刻度线和标签对齐，boundaryGap为true时有效
                        show: true,

                    },
                    axisLabel:{
                        inside: true,
                    },
                    axisLine: {
                        symbol: ['none', 'arrow']
                    },
                    // min: data.result.AxisXBegin,
                    // max: data.result.AxisXEnd,
                    // scale: true,
                },
                {
                    // type: 'value',
                    name:'round',
                    axisLine:{
                        show: true
                    },
                    offset:'-750',
                    data:['时间5','时间6','时间7','时间8'],
                    boundaryGap: true,
                    axisLabel:{
                        inside: false,
                    },
                    axisLine: {
                        symbol: ['none', 'arrow']
                    },
                    axisTick: { //刻度线
                        alignWithLabel:true,  //刻度线和标签对齐，boundaryGap为true时有效
                    },
                },
                {
                    // type: 'value',
                    name:'block',
                    axisLine:{
                        show: true
                    },
                     axisLine: {
                        symbol: ['none', 'arrow']
                    },
                    data:value,
                    boundaryGap: true,
                    axisTick: { //刻度线
                        alignWithLabel:true,  //刻度线和标签对齐，boundaryGap为true时有效
                    },
                },
                {
                    // type: 'time',
                    axisLine:{
                        show: true
                    },
                     axisLine: {
                        symbol: ['none', 'arrow']
                    },
                    data:time,
                    boundaryGap: true,
                    axisLabel:{
                        inside: true,
                    },
                    axisTick: { //刻度线
                        alignWithLabel:true,  //刻度线和标签对齐，boundaryGap为true时有效
                    },
                }
            ],
            yAxis: {
                type: 'category',
                name:'validator',
                data: this.state.AxisY,
                triggerEvent: true,
                axisLabel:{
                    margin:8,
                    formatter:function(data){          
                        var val=''
                        if(data.length>4){
                            val = data.substr(0,4)+'...';
                            return val ;
                        }else {
                            return data;
                        }
                    }
                },
                // min: 0,
                // max: 5,
                // scale: true,
                axisTick: {
                    alignWithLabel: true
                }
            },
            toolbox: {
                feature: {
                    dataZoom: {}
                }
            },
            // dataZoom: {
            //     type: 'inside'
            // },
            series: series,
        }; 
        myChart.setOption(option);

        extension(myChart);
        function extension(myChart){
            var elementDiv = document.getElementById('extension');
            if(!elementDiv){
                var div = document.createElement('div')
                div.setAttribute('id', 'extension')
                div.style.display = 'block'
                document.querySelector('html').appendChild(div)
            }
            myChart.on('mouseover',function(params){
                if (params.componentType == 'yAxis') {
                    var elementDiv = document.querySelector('#extension')
                    var elementStyle =
                      'position: absolute;margin-left:35px;z-index: 99999;color: #fff;font-size: 12px;padding: 5px;display: inline;border-radius: 4px;background-color: #303133;box-shadow: rgba(0, 0, 0, 0.3) 2px 2px 8px'
                    elementDiv.style.cssText = elementStyle
                    elementDiv.innerHTML = params.value
                    document.querySelector('html').onmousemove = function (event) {
                      var elementDiv = document.querySelector('#extension')
                      var xx = event.pageX - 10
                      var yy = event.pageY + 15
                      elementDiv.style.top = yy + 'px'
                      elementDiv.style.left = xx + 'px'
                    }
                  }
            })
            myChart.on('mouseout', function (params) {
                if (params.componentType == 'yAxis') {
                  var elementDiv = document.querySelector('#extension')
      
                  elementDiv.style.cssText = 'display:none'
                }
              })
        }

    })


    
    
  }
  render() {
    return (
        <div id="main" className="container" style={{ padding: '50px', boxSizing:'border-box',  width: '100%', height: 1000 }}> 
        </div>
    );
  }
}
export default App;
